diff --git a/modules/ratelimit/Makefile b/modules/ratelimit/Makefile
index 200c8b9..c06869e 100644
--- a/modules/ratelimit/Makefile
+++ b/modules/ratelimit/Makefile
@@ -13,4 +13,5 @@ DEFS+=-DOPENSER_MOD_INTERFACE
 
 SERLIBPATH=../../lib
 SER_LIBS+=$(SERLIBPATH)/kcore/kcore
+SER_LIBS+=$(SERLIBPATH)/kmi/kmi
 include ../../Makefile.modules
diff --git a/modules/ratelimit/ratelimit.c b/modules/ratelimit/ratelimit.c
index 8d57243..d11884d 100644
--- a/modules/ratelimit/ratelimit.c
+++ b/modules/ratelimit/ratelimit.c
@@ -40,6 +40,7 @@
 #include "../../sr_module.h"
 #include "../../dprint.h"
 #include "../../timer.h"
+#include "../../timer_ticks.h"
 #include "../../ut.h"
 #include "../../locking.h"
 #include "../../mod_fix.h"
@@ -136,6 +137,10 @@ typedef struct rl_queue {
 	str             method_mp;
 } rl_queue_t;
 
+
+struct timer_ln *t;
+int foo;
+
 /* === these change after startup */
 gen_lock_t * rl_lock;
 
@@ -194,7 +199,7 @@ static regex_t queue_params_regex;
 
 /** module functions */
 static int mod_init(void);
-static void rl_timer(unsigned int, void *);
+static ticks_t rl_timer_handle(ticks_t, struct timer_ln *, void *);
 static int w_rl_check_default(struct sip_msg*, char *, char *);
 static int w_rl_check_forced(struct sip_msg*, char *, char *);
 static int w_rl_check_forced_pipe(struct sip_msg*, char *, char *);
@@ -431,10 +436,14 @@ static int mod_init(void)
 	}
 
 	/* register timer to reset counters */
-	if (register_timer_process(rl_timer, NULL, timer_interval, TIMER_PROC_INIT_FLAG) < 0) {
-		LM_ERR("could not register timer function\n");
+	t = timer_alloc();
+	if (t==NULL) {
+		LM_ERR("vould not alloc timer\n");
 		return -1;
 	}
+	timer_init(t, rl_timer_handle, &foo, F_TIMER_FAST);
+	foo = 0;
+	timer_add(t, MS_TO_TICKS(1500)); /* start it after 1500ms */
 
 	/* load the SL API */
 	if (load_sl_api(&slb)!=0) {
@@ -1096,7 +1105,7 @@ static int add_queue_params(modparam_t type, void * val)
 
 
 /* timer housekeeping, invoked each timer interval to reset counters */
-static void rl_timer(unsigned int ticks, void *param)
+static ticks_t rl_timer_handle(ticks_t ticks, struct timer_ln* tl, void* data)
 {
 	int i, len;
 	char *c, *p;
@@ -1132,6 +1141,8 @@ static void rl_timer(unsigned int ticks, void *param)
 		*pipes[i].counter = 0;
 	}
 	LOCK_RELEASE(rl_lock);
+
+	return (ticks_t)(-1); /* periodical */
 }
 
 
